<template>
  <ModalsBase
    :id="id"
    title="Save preset"
    :footer="true"
    :header="true"
    :ok-disabled="!formIsValid"
    ok-title="Save"
    bodyclass="p-0"
    :visible="visible"
    @ok="savePreset()"
    @hidden="$emit('hidden')"
    @shown="$emit('shown')"
  >
    <template #body>
      <div class="p-3">
        <div class="mb-3">
          <b-form-group
            v-if="userPresetSelected"
            v-slot="{ ariaDescribedby }"
            label="Save as"
          >
            <b-form-radio-group
              id="radio-group-1"
              v-model="mode"
              :options="[
                { text: 'New Preset', value: 'create' },
                { text: 'Overwrite Preset', value: 'overwrite' },
              ]"
              :aria-describedby="ariaDescribedby"
              name="radio-options"
            ></b-form-radio-group>
          </b-form-group>
          <div class="subheader mb-2">Title</div>
          <b-form-input
            v-model.trim="$v.title.$model"
            data-cy="input-title-create-preset"
            placeholder="Title for the preset"
            class="mb-1"
            :class="{ 'is-invalid': $v.title.$error }"
          >
          </b-form-input>
          <!-- title input errors -->
          <template v-if="$v.title.$dirty">
            <div
              v-if="!$v.title.required"
              data-cy="error-title-create-preset"
              class="text-red small"
            >
              Title is required
            </div>
          </template>
          <!-- /title input errors -->
        </div>
        <div>
          <div class="subheader mb-2">Description</div>
          <textarea
            v-model.trim="$v.description.$model"
            data-cy="input-description-create-preset"
            class="form-control textarea-project-description"
            placeholder="Description for the preset"
            rows="4"
            maxlength="200"
            :class="{ 'is-invalid': $v.description.$error }"
          >
          </textarea>
          <!-- description input errors -->
          <template v-if="$v.description.$dirty">
            <div
              v-if="!$v.description.required"
              data-cy="error-title-create-preset"
              class="text-red small"
            >
              Description required
            </div>
            <div
              v-if="!$v.description.maxLength"
              data-cy="error-long-description-create-preset"
              class="text-red small"
            >
              Description should be shorter than 200 characters
            </div>
          </template>
          <!-- description input errors -->
        </div>
      </div>
    </template>
  </ModalsBase>
</template>
<script>
import { required, maxLength } from 'vuelidate/lib/validators';
import { mapGetters } from 'vuex';
import notificationsMixin from '~/mixins/notifications.js';
export default {
  mixins: [notificationsMixin],
  props: {
    id: {
      type: String,
      default: '',
    },
    query: {
      type: String,
      default: '',
    },
    visible: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      title: '',
      description: '',
      mode: '',
    };
  },
  computed: {
    ...mapGetters({
      userPresetSelected: 'presets/getUserPreset',
    }),
    formIsValid() {
      return !this.$v.$invalid;
    },
  },
  watch: {
    userPresetSelected(data) {
      this.title = data?.label || '';
      this.description = data?.description || '';
    },
  },
  mounted() {
    this.title = this.userPresetSelected?.label || '';
    this.description = this.userPresetSelected?.description || '';
    this.mode = this.userPresetSelected ? 'overwrite' : 'create';
  },
  methods: {
    async savePreset() {
      try {
        let response;
        if (!this.userPresetSelected || this.mode === 'create') {
          response = await this.$nuxt.context.store.dispatch(
            'presets/createPresets',
            {
              scenarioId: this.$nuxt.$route.params.scenarioId,
              title: this.title,
              description: this.description,
              query: this.query,
            }
          );
          this.mode = 'overwrite';
        } else {
          response = await this.$nuxt.context.store.dispatch(
            'presets/updatePresets',
            {
              scenarioId: this.$nuxt.$route.params.scenarioId,
              presetId: this.userPresetSelected.presetId,
              title: this.title,
              description: this.description,
              query: this.query,
            }
          );
        }
        if (response && response.data) {
          this.$nuxt.context.store.dispatch('presets/getPresets', {
            scenarioId: this.$nuxt.$route.params.scenarioId,
          });
          this.showNotification('Preset saved successfully!', 'Saved!');
          const newNode = { ...this.userPresetSelected };
          newNode.presetId = response.data.id;
          newNode.label = response.data.title;
          newNode.description = response.data.description;
          newNode.query = response.data.query;
          this.$nuxt.context.store.commit('presets/updateUserPreset', newNode);
        }
      } catch (error) {
        this.showErrorNotification('Error saving preset');
      }
    },
  },
  validations: {
    title: {
      required,
    },
    description: {
      required,
      maxLength: maxLength(200),
    },
  },
};
</script>
